/// The name of an `NSAppearance`, an object that manages standard appearance
/// attributes for UI elements in an app.
enum NSAppearanceName {
  /// The standard light system appearance.
  aqua,

  /// The standard dark system appearance.
  darkAqua,

  /// The light vibrant appearance, available only in visual effect views.
  vibrantLight,

  /// A dark vibrant appearance, available only in visual effect views.
  vibrantDark,

  /// A high-contrast version of the standard light system appearance.
  accessibilityHighContrastAqua,

  /// A high-contrast version of the standard dark system appearance.
  accessibilityHighContrastDarkAqua,

  /// A high-contrast version of the light vibrant appearance.
  accessibilityHighContrastVibrantLight,

  /// A high-contrast version of the dark vibrant appearance.
  accessibilityHighContrastVibrantDark,
}
