/// An enum containing all components of `NSColor` whose type is `CGFloat`.
enum NSColorComponent {
  /// The alpha (opacity) component value of the color.
  alphaComponent,

  /// The white component value of the color.
  whiteComponent,

  /// The red component value of the color.
  redComponent,

  /// The green component value of the color.
  greenComponent,

  /// The blue component value of the color.
  blueComponent,

  /// The cyan component value of the color.
  cyanComponent,

  /// The magenta component value of the color.
  magentaComponent,

  /// The yellow component value of the color.
  yellowComponent,

  /// The black component value of the color.
  blackComponent,

  /// The hue component value of the color.
  hueComponent,

  /// The saturation component value of the color.
  saturationComponent,

  /// The brightness component value of the color.
  brightnessComponent,
}
